#ifndef PCE_CPU_H
#define PCE_CPU_H

#include "types.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef void (*io_writer)(byte v);
typedef byte (*io_reader)();

extern dword cpu_cycles_counter;
extern byte irq_mask, irq_status;

void init_cpu();
void trash_cpu();

//void reset_cpu();
int run_cpu(dword cycles_todo);

void new_rom(byte *rom_data, dword pages);

void set_io_read(dword address, io_reader func);
void set_io_write(dword address, io_writer func);

#ifdef __cplusplus
}
#endif


#endif
