#ifndef PCE_IO_H
#define PCE_IO_H

#define SCANLINES_PER_FRAME 263
#define BASE_CLOCK 7160000
#define CYCLES_PER_SCANLINE (BASE_CLOCK/(SCANLINES_PER_FRAME*60))
#define TIMER_PERIOD (BASE_CLOCK/1000*3*1024/21480)

#define JOY_LEFT          0x80
#define JOY_DOWN          0x40
#define JOY_RIGHT         0x20
#define JOY_UP            0x10
#define JOY_RUN           0x08
#define JOY_SELECT        0x04
#define JOY_B		      0x02
#define JOY_A		      0x01

#define INT_NONE  0
#define INT_IRQ	  1
#define INT_NMI	  2
#define INT_QUIT  3
#define	INT_TIMER 4

typedef struct tagIO {
	pair VDC[32];
	pair VCE[0x200];
	pair vce_reg;
	byte vce_cr;
	word vdc_inc,vdc_raster_count;
	byte vdc_reg,vdc_status,vdc_ratch,vce_ratch;
	byte vdc_satb;
	byte vdc_pendvsync;
	int bg_h,bg_w;
	int screen_w,screen_h;
	int scroll_y;
	int minline, maxline;

	byte JOY[16];
	byte joy_select, joy_counter;

	//byte PSG[6][8],wave[6][32],wavofs[6];
	//byte psg_ch,psg_volume,psg_lfo_freq,psg_lfo_ctrl;

	byte timer_reload, timer_start, timer_counter;

	//byte irq_mask, irq_status;

	//int backup,adpcm_firstread;
	//pair adpcm_ptr;
	//word adpcm_rptr,adpcm_wptr;
} IO;

extern IO io;

void init_io();
void reset_io();

void timer_tick();

#endif
