#ifndef MVECTOR_H
#define MVECTOR_H

template<class T>
class mvector
{
	enum { MIN_SIZE = 8 };

	T *buffer;
	int length, capacity;

	void init(int capacity)
	{
		this->buffer = 0;
		this->length = 0;
		this->capacity =capacity;
		this->buffer = new T[capacity];
	}

	void grow()
	{
		T *old_buffer = this->buffer;
		this->capacity <<= 1;
		this->buffer = new T[this->capacity];
		for (int i = 0; i < this->length; i++) this->buffer[i] = old_buffer[i];
		delete[] old_buffer;
	}

public:

	explicit mvector(int capacity = MIN_SIZE)
	{
		init(capacity < MIN_SIZE ? MIN_SIZE : capacity);
	}

	/*
	mvector()
	{
		init(MIN_SIZE);
	}
	*/

	~mvector()
	{
		if (this->buffer) delete[] this->buffer;
	}

	T operator[](int index) const
	{
		return this->buffer[index];
	}

	bool empty() const
	{
		return this->length == 0;
	}

	int size() const
	{
		return this->length;
	}

	void clear()
	{
		this->length = 0;
	}

	void append(const T t)
	{
		if (this->length >= this->capacity) grow();
		this->buffer[this->length++] = t;
	}
};

#endif
